package com.yongqi.xinrenli.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.yongqi.xinrenli.domain.bo.DbUserDiscountBo;
import com.yongqi.xinrenli.domain.vo.DbUserDiscountVo;
import com.yongqi.xinrenli.domain.DbUserDiscount;
import com.yongqi.xinrenli.mapper.DbUserDiscountMapper;
import com.yongqi.xinrenli.service.IDbUserDiscountService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 用户折扣Service业务层处理
 *
 * @author zyf
 * @date 2023-03-09
 */
@RequiredArgsConstructor
@Service
public class DbUserDiscountServiceImpl implements IDbUserDiscountService {

    private final DbUserDiscountMapper baseMapper;

    /**
     * 查询用户折扣
     */
    @Override
    public DbUserDiscountVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询用户折扣列表
     */
    @Override
    public TableDataInfo<DbUserDiscountVo> queryPageList(DbUserDiscountBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<DbUserDiscount> lqw = buildQueryWrapper(bo);
        Page<DbUserDiscountVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询用户折扣列表
     */
    @Override
    public List<DbUserDiscountVo> queryList(DbUserDiscountBo bo) {
        LambdaQueryWrapper<DbUserDiscount> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<DbUserDiscount> buildQueryWrapper(DbUserDiscountBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<DbUserDiscount> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getUserId() != null, DbUserDiscount::getUserId, bo.getUserId());
        lqw.eq(bo.getDiscountRatio() != null, DbUserDiscount::getDiscountRatio, bo.getDiscountRatio());
        lqw.eq(bo.getUseStatus() != null, DbUserDiscount::getUseStatus, bo.getUseStatus());
        lqw.eq(bo.getModifyTime() != null, DbUserDiscount::getModifyTime, bo.getModifyTime());
        return lqw;
    }

    /**
     * 新增用户折扣
     */
    @Override
    public Boolean insertByBo(DbUserDiscountBo bo) {
        DbUserDiscount add = BeanUtil.toBean(bo, DbUserDiscount.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改用户折扣
     */
    @Override
    public Boolean updateByBo(DbUserDiscountBo bo) {
        DbUserDiscount update = BeanUtil.toBean(bo, DbUserDiscount.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(DbUserDiscount entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除用户折扣
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
